summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMaarten Thibaut <murphy@gentoo.org>2002-04-25 21:19:27 +0000
committerMaarten Thibaut <murphy@gentoo.org>2002-04-25 21:19:27 +0000
commit6d54e47e5142dd366524175b5e10f46fe8074da7 (patch)
treea509ae5cea09d05b784bf14d6568f5995e7fb0c4 /sys-kernel/sparc-sources
parentgnome friendliness (diff)
downloadhistorical-6d54e47e5142dd366524175b5e10f46fe8074da7.tar.gz
historical-6d54e47e5142dd366524175b5e10f46fe8074da7.tar.bz2
historical-6d54e47e5142dd366524175b5e10f46fe8074da7.zip
Needed for generating /usr/include/asm.
"Borrowed" from debian. Thanks guys.
Diffstat (limited to 'sys-kernel/sparc-sources')
-rw-r--r--sys-kernel/sparc-sources/files/generate-asm-sparc68
1 files changed, 68 insertions, 0 deletions
diff --git a/sys-kernel/sparc-sources/files/generate-asm-sparc b/sys-kernel/sparc-sources/files/generate-asm-sparc
new file mode 100644
index 000000000000..5e247a26f635
--- /dev/null
+++ b/sys-kernel/sparc-sources/files/generate-asm-sparc
@@ -0,0 +1,68 @@
+#!/bin/sh -e
+
+# Idea borrowed from RedHat's kernel package
+
+if [ -n "$1" ]; then
+ if [ ! -d "$1" ]; then
+ echo "$1" does not exist, or is not a directory
+ exit 1
+ fi
+ cd $1
+else
+ cd /usr/include
+fi
+
+if [ ! -d asm-sparc -o ! -d asm-sparc64 ] ; then
+ echo E: asm-sparc and asm-sparc64 must exist, or you will have problems
+ exit 1
+fi
+
+rm -rf asm
+mkdir asm
+
+for h in `( ls asm-sparc; ls asm-sparc64 ) | grep '\.h$' | sort -u`; do
+ name=`echo $h | tr a-z. A-Z_`
+ # common header
+ cat > asm/$h << EOF
+/* All asm/ files are generated and point to the corresponding
+ * file in asm-sparc or asm-sparc64. To regenerate, run "generate-asm"
+ */
+
+#ifndef __SPARCSTUB__${name}__
+#define __SPARCSTUB__${name}__
+
+EOF
+
+ # common for sparc and sparc64
+ if [ -f asm-sparc/$h -a -f asm-sparc64/$h ]; then
+ cat >> asm/$h <<EOF
+#ifdef __arch64__
+#include <asm-sparc64/$h>
+#else
+#include <asm-sparc/$h>
+#endif
+EOF
+
+ # sparc only
+ elif [ -f asm-sparc/$h ]; then
+ cat >> asm/$h <<EOF
+#ifndef __arch64__
+#include <asm-sparc/$h>
+#endif
+EOF
+ # sparc64 only
+ else
+ cat >> asm/$h <<EOF
+#ifdef __arch64__
+#include <asm-sparc64/$h>
+#endif
+EOF
+ fi
+
+ # common footer
+ cat >> asm/$h <<EOF
+
+#endif /* !__SPARCSTUB__${name}__ */
+EOF
+
+done